<script lang="ts">
import Vue from 'vue';
import Accordion from '../solutions/accordion.vue';
import AccordionList from './accordion-list.vue';
import CallOut from './call-out.vue';
import { SolutionsVideoModal } from '../solutions/index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';
import QuoteCarousel from '../common/quote-carousel.vue';

export default Vue.extend({
  name: 'Tabs',
  components: {
    Accordion,
    AccordionList,
    SolutionsVideoModal,
    CallOut,
    QuoteCarousel,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      videoUrl: '',
      tabs: [],
      firstTab: null,
      lastTab: null,
      tabpanels: [],
      selectedTab: 0,
      videos: [],
      modal: {
        open: false,
      },
      isOpenIndex: 0,
    };
  },
  created() {
    this.videos = this.data.tabs.flatMap((tab) => {
      return tab.tabPanelContent.accordion.flatMap((accordionItem) => {
        return accordionItem.ctas
          .map((cta) => {
            if (cta.modal) {
              return cta.externalUrl;
            } else {
              return null;
            }
          })
          .filter((url) => url !== null);
      });
    });
  },
  methods: {
    isVideoModalVisible(video: string): boolean {
      return this.modal.open && this.videoUrl === video;
    },

    onTabChange(value: number) {
      this.selectedTab = value;
      this.isOpenIndex = 0;
    },
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
    closeModal() {
      this.modal.open = false;
      this.videoUrl = '';
    },
    openVideoModal(video: any) {
      this.videoUrl = video;
      this.modal.open = true;
    },
  },
});
</script>

<template>
  <section class="platform-tabs">
    <SlpContainer>
      <SlpTypography
        tag="h2"
        variant="heading1-bold"
        class="gradient-header slp-mb-8"
      >
        {{ data.title }}
      </SlpTypography>
      <SlpTypography tag="h4" variant="heading4-bold">
        {{ data.subtitle }}
      </SlpTypography>
      <SlpRow class="platform-tabs__row">
        <SlpColumn :cols="6" class="slp-pr-md-16">
          <div v-if="data?.image?.image_url" class="platform-tabs__container">
            <nuxt-img
              class="platform-tabs__image"
              :src="data.image.image_url"
              :alt="data.image.alt"
              aria-hidden="true"
              :data-aos="data.left_block_animation"
              :data-aos-duration="data.left_block_duration"
              loading="lazy"
            />
          </div>
        </SlpColumn>
        <SlpColumn :cols="6" class="slp-pl-md-16">
          <div class="platform-tabs__wrapper">
            <div
              class="platform-tabs__tabs"
              role="tablist"
              aria-labelledby="tablist-1"
            >
              <button
                v-for="(tab, tabIndex) in data.tabs"
                :id="`tab-${tabIndex}`"
                :key="tab.tabButtonText"
                ref="tab"
                type="button"
                role="tab"
                aria-selected="true"
                :aria-controls="`tabpanel-${tabIndex}`"
                class="platform-tabs__tab"
                :class="
                  selectedTab == tabIndex ? 'platform-tabs__tab--active' : ''
                "
                :data-ga-name="tab.data_ga_name"
                :data-ga-location="tab.data_ga_location"
                @click="onTabChange(tabIndex)"
              >
                <SlpTypography variant="heading5-bold" tag="span">
                  <span class="">{{ tab.tabButtonText }} </span>
                </SlpTypography>
              </button>
            </div>
            <div
              v-for="(tabContent, tabContentIndex) in data.tabs"
              v-show="tabContentIndex === selectedTab"
              :id="`tabpanel-${tabContentIndex}`"
              :key="`tab-content-${tabContentIndex}`"
              role="tabpanel"
              tabindex="0"
              :aria-labelledby="`tab-${tabContentIndex}`"
              class="platform-tabs__content"
              :class="
                selectedTab == tabContentIndex
                  ? 'platform-tabs__content--active'
                  : ''
              "
            >
              <Accordion
                v-for="(item, index) in tabContent.tabPanelContent.accordion"
                :key="item.header"
                :data="item"
                :is-open="isOpenIndex == index"
                @toggleController="toggleController(index)"
              >
                <template #additional-content>
                  <AccordionList
                    :data="item.headerCtas"
                    @onOpenVideoModal="openVideoModal"
                    @onCloseModal="closeModal"
                  />
                  <SlpTypography variant="body1-bold" tag="p" class="slp-my-16">
                    {{ item.ctaHeader }}
                  </SlpTypography>
                  <AccordionList
                    :data="item.ctas"
                    @onOpenVideoModal="openVideoModal"
                    @onCloseModal="closeModal"
                  />
                </template>
              </Accordion>
            </div>
            <div class="platform-tabs__cta">
              <CallOut :data="data.tabs[selectedTab].tabPanelContent.cta" />
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
      <quote-carousel
        v-bind="data.tabs[selectedTab].tabPanelContent.case_study"
      />

      <div v-for="(video, index) in videos" :key="`${video}-${index}`">
        <SolutionsVideoModal
          v-show="isVideoModalVisible(video)"
          :key="`${video}-${index}`"
          light-background
          :visible="isVideoModalVisible(video)"
          @close="closeModal"
        >
          <template #body>
            <lite-vimeo
              :id="`${video}`"
              :videoid="getVimeoVideoId(createVideoSource(video))"
              autoplay
            ></lite-vimeo>
          </template>
        </SolutionsVideoModal>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.platform-tabs {
  background: $color-surface-700;
  color: $color-surface-50;
  padding: $spacing-64 0 $spacing-32 0;
  @media (min-width: $breakpoint-sm) {
    padding: $spacing-48 0 $spacing-64 0;
  }
  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0 $spacing-64 0;
  }
  &__header {
    max-width: 480px;
    background: linear-gradient(
      91.08deg,
      #feb484 1.97%,
      #a686f2 27.88%,
      #592ac8 65.98%
    );
    background-clip: text;
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
  }
  &__tabs {
    display: flex;
    flex-wrap: wrap;
    padding: $spacing-32 0 0 0;
    @media (min-width: $breakpoint-md) {
      display: block;
    }
  }
  &__tab {
    background: $color-surface-600;
    border-radius: 90px;
    border: none;
    color: $color-surface-50;
    margin-right: $spacing-8;
    padding: $spacing-8 $spacing-24;
    margin-bottom: $spacing-16;
    transition: all 0.3s ease;
    cursor: pointer;
    flex: 0 0 auto;
    @media (min-width: $breakpoint-md) {
      margin-right: $spacing-24;
    }
    &:hover,
    &:focus,
    &:active,
    &--active {
      background: $color-accent-500;
    }
  }
  &__feature-header {
    display: block;
    color: $color-accent-400;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }
  &__content {
    opacity: 0;
    img {
      width: 100%;
    }
    &--active {
      animation: fade-in 0.3s linear forwards 0.1s;
    }
  }
  &__feature {
    color: $color-surface-50;
    display: flex;
    align-items: center;
    margin-bottom: $spacing-32;
    &__button {
      color: $color-surface-50;
      display: inline-block;
      text-align: left;
      :deep {
        .slp-icon {
          display: inline-flex;
          align-items: center;
          margin-left: 3px;
          width: 16px;
          height: 16px;
          position: relative;
          top: 2px;
          div {
            position: absolute;
            display: inline-flex;
            align-items: center;
            margin-bottom: -2px;
          }
        }
      }
    }
  }
  &__button-icon {
    color: $color-accent-400;
  }
  &__icon-stroke {
    stroke: currentColor;

    :deep path {
      stroke: currentColor;
    }
  }
  &__blurb {
    max-width: 800px;
  }
  &__row {
    @media (min-width: $breakpoint-md) {
      margin-left: -16px;
      flex-direction: row-reverse;
    }
  }

  &__col {
    padding-left: 32px;
    &--media {
      :deep .container {
        margin-bottom: 0;
      }
    }
  }

  @keyframes fade-in {
    from {
      opacity: 0;
      transform: translateY(10px);
    }
    to {
      opacity: 1;
      transform: translateY(0);
    }
  }

  &__img-container {
    line-height: 0;
  }

  // Demo styling
  .demo-modal {
    position: relative;
  }
  .demo-thumbnail {
    max-width: 100%;
    display: block;
    height: auto;
    filter: blur(1px);
    z-index: 1;
    transition: filter 0.3s ease-in-out;
  }
  .demo-button {
    position: absolute;
    top: 40%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 2;
    border-radius: 30px;
    width: 228px;
    display: flex;
    justify-content: center;
    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
    }
    .slp-icon {
      margin-right: 5px;
      width: 24px;
      height: 24px;
    }
  }
  :deep .accordion {
    color: #fff;
    margin: 48px 0 32px 0;
    .accordion__header {
      color: #fff;
    }
    .accordion__icon {
      color: #fff;
      &:before,
      &::after {
        background-color: currentColor;
      }
    }
    .summary {
      border: none;
      padding: 14px 0;
    }
    .content-container {
      padding-bottom: 0;
    }
  }
  .gradient-header {
    display: inline-block;
    background: linear-gradient(
      123deg,
      #f9a026 0%,
      #a686f2 45.5%,
      #592ac8 100%
    );
    -webkit-background-clip: text;
    background-clip: text;
    -webkit-text-fill-color: transparent;
  }
  &__container {
    position: relative;
    text-align: center;
    @media (max-width: $breakpoint-lg) {
      margin-bottom: $spacing-48;
    }

    .platform-tabs__image {
      max-width: 450px;
      width: 100%;
      max-height: 800px;
      margin-top: 0;
      @media (max-width: $breakpoint-lg) {
        margin-top: 48px;
      }
    }
  }
  :deep .slp-col-md-6 {
    width: 100%;
  }
}
</style>
